#ifndef _IDSA_TABLE_H_
#define _IDSA_TABLE_H_

#include <time.h>
#include <idsa_internal.h>

#include "types.h"

struct table_unit{
  IDSA_UNIT *u_unit;
  int u_count;
  RULE_MATCH **u_match;
};

struct table_head{
  IDSA_LOOKUP_UNIT *h_lookup; /* for comparsion etc */
  unsigned int h_type;  /* unit types we are handling */

  int h_reserved; /* is it reserved ? */
  char h_name[IDSA_M_NAME]; /* name of this unit */

  int h_utotal; /* count of all units (all h->h_intersect) */
  int h_ucount; /* count of units (just for this one) */
  TABLE_UNIT *h_units;

  TABLE_HEAD *h_intersect; /* for intersection of ranges we need fallback */
};

void table_free(TABLE_HEAD *h);

RULE_MATCH *table_match_make(STATE_SET *s, unsigned int t, char *n, char *p);

/* run time *****************************************************************/

int table_trigger(TABLE_HEAD *h, IDSA_EVENT *e);

#include <stdio.h>

int table_dump(TABLE_HEAD *h, FILE *f);

/* turf */

TABLE_HEAD *table_find(UNION_BRANCH *b, char *n);
RULE_MATCH *table_constant(TABLE_HEAD *h, IDSA_UNIT *u);
TABLE_HEAD *table_new(unsigned int t, char *n);

#endif
