#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <errno.h>
#include <unistd.h>

#include <udomain.h>

int main(int argc, char **argv)
{
  int result = 0;
  int i, j, fd, c;
  char *name;

  name = NULL;
  i = 1;
  j = 1;
  while (i < argc) {
    if (argv[i][0] == '-') {
      switch (argv[i][j]) {
      case 'c':
	printf("(c) 2000 Marc Welz: Licensed under the terms of the GNU General Public License\n");
	exit(0);
	break;
      case 'h':
	printf("Usage: %s socket\n", argv[0]);
	exit(0);
	break;
      case '-':
	j++;
	break;
      case '\0':
	j = 1;
	i++;
	break;
      default:
	fprintf(stderr, "%s: unknown option -%c\n", argv[0], argv[i][j]);
	exit(2);
	break;
      }
    } else {
      name = argv[i];
      i = argc;
    }
  }

  if (name == NULL) {
    fprintf(stderr, "%s: require a unix domain socket as argument\n", argv[0]);
    exit(1);
  }
  fd = udomainconnect(name);
  if (fd < 0 || (dup2(fd, STDOUT_FILENO) != STDOUT_FILENO)) {
    fprintf(stderr, "%s: unable to connect to %s: %s\n", argv[0], name, strerror(errno));
    exit(1);
  }
  /* this is a debugging tool, efficiency is not important */
  while (1) {
    c = getchar();
    if (c == EOF || (putchar(c) == EOF)) {
      break;
    }
  }

  if (errno) {
    fprintf(stderr, "%s: error for %s: %s\n", argv[0], name, strerror(errno));
    result++;
  }
  return result;
}
